using System.ComponentModel;
using Dapfor.Net.Data;

namespace Dapfor.Net.Demo.Examples.DataBinding.HierarchicalDatabinding
{
    public class Customer
    {
        private readonly string _company;
        private readonly string _name;
        private readonly BindingList<Order> _orders = new BindingList<Order>();
        private readonly string _phone;

        public Customer(string name, string company, string phone)
        {
            _name = name;
            _company = company;
            _phone = phone;
        }

        public string Name
        {
            get { return _name; }
        }

        public string Company
        {
            get { return _company; }
        }

        public string Phone
        {
            get { return _phone; }
        }

        [HierarchicalField]
        public BindingList<Order> Orders
        {
            get { return _orders; }
        }
    }
}