using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using Dapfor.Net.Editors;

namespace Dapfor.Net.Demo.Examples.DataBinding.Populating
{
    public class ProductEditor : DropDownEditor
    {
        private readonly IList<string> _products;

        public ProductEditor(IList<string> products)
        {
            _products = products;
        }

        public override void Populate(ListBox listBox, object value, ref ContentAlignment alignment)
        {
            foreach (string product in _products)
            {
                listBox.Items.Add(product);
            }
        }

        public override object EndEdit(ListBox listBox, object value)
        {
            if (listBox.SelectedItem != null)
            {
                return listBox.SelectedItem;
            }
            return value;
        }
    }
}