using System.Windows.Forms;
using Dapfor.Net.Demo.Internal;
using Dapfor.Net.Ui;


namespace Dapfor.Net.Demo.Examples.Features.DataValidation
{
    [Example("Data validation", "Features")]
    public partial class DataValidationForm : UserControl
    {
        public DataValidationForm()
        {
            InitializeComponent();

            //Populate grid with data
            int j = 0;
            for(int i = 0; i < 100; i++)
            {
                grid.Rows.Add(new int[] { j++, j++, j++, j++, j++, j++, j++, j++});
            }
        }

        private void OnDisplayErrorsCheckedChanged(object sender, System.EventArgs e)
        {
            rbDefaultMessages.Enabled = cbDisplayErrors.Checked;
            rbCustomMessage.Enabled = cbDisplayErrors.Checked;
            tbMessage.Enabled = cbDisplayErrors.Checked;
        }

        private void OnValidateCell(object sender, ValidateCellEventArgs e)
        {
            //Default validation logic:
            bool valid = e.Exception == null && string.IsNullOrEmpty(e.ErrorText);

            //Add your validation logic here. 
            //valid = ... 

            if (!valid)
            {
                if(cbDisplayErrors.Checked)
                {
                    //Display a custom message.
                    if (rbCustomMessage.Checked)
                    {
                        e.ErrorText = tbMessage.Text;
                    }    
                }
                else
                {
                    e.ErrorText = string.Empty;
                }

                if (rbRestart.Checked)
                {
                    e.Action = ValidateCellAction.RestartEdit;
                }
                if(rbCancel.Checked)
                {
                    e.Action = ValidateCellAction.CancelValue;
                }
                else if (rbStop.Checked)
                {
                    e.Action = ValidateCellAction.StopEdit;
                }
            }
        }
    }
}