using Dapfor.Net.Demo.Properties;
using Dapfor.Net.Editors;
using Dapfor.Net.Ui;

namespace Dapfor.Net.Demo.Examples.Features.SharedData
{
    public class IconBoolEditor : UITypeEditorEx
    {
        public override bool GetPaintCellSupported()
        {
            return true;
        }

        public override void PaintCell(PaintCellEventArgs e)
        {
            if (Equals(true, e.Cell.Value))
            {
                e.Image = Resources.check;
            }
            else if (Equals(false, e.Cell.Value))
            {
                e.Image = Resources.fatal;
            }
        }

        public override StopEditReason EditCell(IGridEditorService service, Cell cell, StartEditReason reason)
        {
            if (Equals(false, cell.Value))
            {
                cell.Value = true;
            }
            else if (Equals(true, cell.Value))
            {
                cell.Value = false;
            }
            return StopEditReason.UserStop;
        }
        
        public override bool Navigable
        {
            get { return false; }
        }
    }
}