using Dapfor.Net.Ui;

namespace Dapfor.Net.Demo.Examples.GridBasics.HitTesting
{
    /// <summary>
    /// The objects of this class will be shown on the top hierarchical level of the <see cref="Grid"/>
    /// </summary>
    public class RootClass
    {
        //Some enumeration
        public enum EnumExample
        {
            Internal,
            External,
        }

        #region Fields

        private readonly int id;
        private double doubleValue;
        private int intValue;
        readonly EnumExample orderType;

        #endregion

        public RootClass(int id, double doubleValue, int intValue, EnumExample orderType)
        {
            this.id = id;
            this.doubleValue = doubleValue;
            this.intValue = intValue;
            this.orderType = orderType;
        }

        #region Public properties


        public int Count
        {
            get { return intValue; }
            set { intValue = value; }
        }

        public double Price
        {
            get { return doubleValue; }
            set { doubleValue = value; }
        }

        public EnumExample OrderType
        {
            get { return orderType; }
        }

        #endregion

        public override string ToString()
        {
            return string.Format("RootClass {0}", id);
        }
    }
}
