using System;
using System.ComponentModel;
using Dapfor.Net.Data;
using Dapfor.Net.Ui;

namespace Dapfor.Net.Demo.Examples.Performance.HierarchicalUpdates
{
    /// <summary>
    /// The objects of this class will be inserted into the <see cref="Grid"/>. When a field of this object is changed, 
    /// it notifies the <see cref="Grid"/> through the <see cref="INotifyPropertyChanged"/> interface. If the notification 
    /// comes from the non-GUI thread, the <see cref="Grid"/> will synchronize threads.
    /// </summary>
    public class DataObject : INotifyPropertyChanged
    {
        #region Fields 

        private int value0;
        private int value1;
        private int value2;
        private int value3;
        private int value4;
        private int value5;
        private int value6;
        private int value7;
        private int value8;
        private int value9;

        #endregion

        #region Public properties

        public DataObject(Random r)
        {
            if(r != null)
            {
                value0 = r.Next();
                value1 = r.Next();
                value2 = r.Next();
                value3 = r.Next();
                value4 = r.Next();
                value5 = r.Next();
                value6 = r.Next();
                value7 = r.Next();
                value8 = r.Next();
                value9 = r.Next();
            }
        }

        [Field("Id0")]
        public int Value0
        {
            get { return value0; }
            set
            {
                value0 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id0"));
                }
            }
        }

        [Field("Id1")]
        public int Value1
        {
            get { return value1; }
            set
            {
                value1 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id1"));
                }
            }
        }

        [Field("Id2")]
        public int Value2
        {
            get { return value2; }
            set
            {
                value2 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id2"));
                }
            }
        }

        [Field("Id3")]
        public int Value3
        {
            get { return value3; }
            set
            {
                value3 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id3"));
                }
            }
        }

        [Field("Id4")]
        public int Value4
        {
            get { return value4; }
            set
            {
                value4 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id4"));
                }
            }
        }

        [Field("Id5")]
        public int Value5
        {
            get { return value5; }
            set
            {
                value5 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id5"));
                }
            }
        }

        [Field("Id6")]
        public int Value6
        {
            get { return value6; }
            set
            {
                value6 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id6"));
                }
            }
        }

        [Field("Id7")]
        public int Value7
        {
            get { return value7; }
            set
            {
                value7 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id7"));
                }
            }
        }

        [Field("Id8")]
        public int Value8
        {
            get { return value8; }
            set
            {
                value8 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id8"));
                }
            }
        }

        [Field("Id9")]
        public int Value9
        {
            get { return value9; }
            set
            {
                value9 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id9"));
                }
            }
        }

        #endregion

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}