using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace Dapfor.Net.Demo.Internal
{
    public partial class ExampleDescription : Panel
    {
        private string _helpFile;
        private string _helpTitle;

        public ExampleDescription()
        {
            InitializeComponent();
            SetStyle(ControlStyles.AllPaintingInWmPaint | ControlStyles.OptimizedDoubleBuffer, true);
        }

        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams p = base.CreateParams;
                p.Style &= p.Style ^ 0x00800000; //WS_BORDER
                p.ExStyle = 0x00020000; //WS_EX_STATICEDGE
                return p;
            }
        }

        private void OnBtnHelpClick(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(_helpFile))
            {
                ContentBrowser.Show(_helpTitle ?? string.Empty, _helpFile);    
            }
        }

        public string HelpTitle
        {
            get { return _helpTitle; }
            set { _helpTitle = value; }
        }

        public string HelpFile
        {
            get { return _helpFile; }
            set { _helpFile = value; }
        }

        [Browsable(true)]
        public override string Text
        {
            get { return tbHint.Text; }
            set { tbHint.Text = value; }
        }
    }
}
