using System;
using System.Windows.Forms;

namespace Dapfor.Net.Demo.Internal
{
    public partial class ExampleHolder : UserControl
    {
        private Control _currentControl;

        public ExampleHolder()
        {
            InitializeComponent();
            SetStyle(ControlStyles.AllPaintingInWmPaint | ControlStyles.OptimizedDoubleBuffer, true);
        }

        public void SetControl(Control control)
        {
            SuspendLayout();
            if (_currentControl != null)
            {
                Controls.Remove(_currentControl);
                _currentControl.Dispose();
                _currentControl = null;
            }
            if (control != null)
            {
                _currentControl = control;
                _currentControl.Size = ClientRectangle.Size;
                _currentControl.SuspendLayout();
                Controls.Add(_currentControl);
                _currentControl.Dock = DockStyle.Fill;
                _currentControl.ResumeLayout(false);
            }
            ResumeLayout(true);
        }


        public void SetControl(Type controlType)
        {
            SuspendLayout();
            if (_currentControl != null)
            {
                Controls.Remove(_currentControl);
                _currentControl.Dispose();
                _currentControl = null;
            }
            if (controlType != null)
            {
                _currentControl = (Control)Activator.CreateInstance(controlType);
                _currentControl.Visible = false;
                _currentControl.Size = ClientRectangle.Size;
                _currentControl.SuspendLayout();
                Controls.Add(_currentControl);
                _currentControl.Dock = DockStyle.Fill;
                _currentControl.ResumeLayout();
                _currentControl.Visible = true;
            }
            ResumeLayout(true);
        }
    }
}